GSoC17 Proposal to provide enhanced usability for Wikimedia Programs & Events Dashboard managed by Wiki Education foundation.
Closed, ResolvedPublic

Description

Purpose
This proposal describes how I will accomplish my Internship at Wikimedia by contributing to WikiEduDashboard.

End Goal
To have added various new features to the Dashboard and increase the overall scope of the project.

Profile Information
Name: Sejal Khatri
Email: sejal.khatri5@gmail.com
IRC Nick: sejal
Mediawiki User: Sek2016
Web Page: http://sejalkhatri.github.io/
Blog: https://medium.com/@sejal.khatri5
Location: India
Time Zone: UTC+5:30
Typical working hours: [12PM to 7PM] and [10PM to 2AM](Indian Standard Time)

Synopsis

The Dashboard code runs 2 main projects

The use case for the Programs & Events Dashboard project is wide and there are many enhancements to be made to increase the user experience, I'll be working on issues related to this and the overall user testing.

Possible mentors
Sage Ross (@Ragesoss )
Jonathan Morgan (@Capt_Swing)

Deliverables
These are the various issues that I found interesting to solve and planning to take them, new issues will be added and solved with time.

Issue1: Delete button on course should be visible but disabled if user can delete but course is active

Issue2: Campaign page should have a way to see the list of articles edited

Issue3: Campaigns index page needs to be redesigned to be useful for admins

Issue4: My Articles buttons should have info mouseovers to explain Assign and Review

Issue5: CoursesUsers should store a copy of user full name, and use that to show instructors

Issue6: Replace all javascript confirm and alert instances with Confirm and Notification components

Issue7: For edit-a-thons (at least), dashboard should give user info about when to expect updated stats

Issue8: On dashboard view, list of archived courses should be sortable

Issue9: Overview should show students information about their own work
Issue9 will be divided into these sub tasks:

  • Add an 'assign myself an article' button (just like from the Students tab) in the Actions component on the overview.
  • Show the student whether they have completed training, and provide a link if they have not.
  • Show the student which articles they are assigned to work on and/or review, and provide links to add/change these articles
  • Show the student how much they have contributed, and how many views their work has had.
  • Links to key resources, including the basic brochures as well as subject-specific guides that are relevant to their course (based on course tags)
  • Work on additional features mentioned in the

Distribution
I have few ideas about how to solve them, So the stages for solving each issue will be:

  1. Getting a clear idea of what the output needs to be.
  2. Implementation
  3. Add tests and get reviews
  4. User testing

I'll distributing them in the time line after having a discussion with the mentor.

Timeline

DateTask
April 3Application deadline
April 4 - May 30Continue contributing to the project.
May 31 - June 25Have a planned sprint and select the issues to be completed. Resolve an issue and add tests for the proposed changes, get reviews, fix and repeat.
June 26Phase 1 Evaluation
June 30Phase 1 deadline
July 1 - July 23Have a planned sprint and select the issues to be completed. Resolve an issue and add tests for the proposed changes, get reviews, fix and repeat.
July 24Phase 2 Evaluation
July 28Phase 2 deadline
July 29 - Aug 20Have a planned sprint and select the issues to be completed. Resolve an issue and add tests for the proposed changes, get the reviews, fix and repeat.
Aug 21Final Review.. Have a final rap up by getting an overall performance review by my mentor, publishing a blog summing up my overall experience of working with Sage and Wikimedia.

Participation
I plan to communicate my work progress mainly through Slack channels and IRC in #wikimedia-ed.
I'll be updating my wiki user page on weekly basis with the progress report.
For version control, I use git. I plan to publish source code on GitHub and get feedback on the same, I understand how contribution and review works with Wiki Edu Dashboard project because of my internship experience. I'll be maintaining my internship blog on Medium and will update it as I advance with the tasks.

About me
I am a Final year undergraduate student of computer science at Pune Institute of Computer Technology.
My major interest is in Web languages(HTML, CSS, JavaScript), Web framework-Ruby on rails and python language and developing UI designs where I have done maximum work. Apart from building applications, I enjoy playing sports and currently I am learning Karate.

I enjoy learning stuff by implementing them and collaborating with other contributors. My experience working on this project and the overall theme of this project drives me to contribute more and be a part of the change it is making :)
Making this project happen means a lot to me because of the learning experience and the after completion user satisfaction look is something I enjoy the most.

I don't have any other time commitments during the program duration as my final examination ends on 27 May.

Past experience
My open source experience began in my second year of engineering, with dual booting my laptop and installing Linux. I was selected as an Outreachy'16 Wikimedia intern (Dec 6 - March 6) for the Wiki Education Dashboard project managed by Wiki Education Foundation. Wiki Ed Dashboard is a platform for helping people get started with editing Articles on Wikipedia and helping professors run assignments where their students edit Wikipedia. I worked on adding customizable user profile pages to the dashboard, which provides info about all the courses user has enrolled in and overall user statistics in those courses encouraging them to contribute more. The technologies that I used during my internship period were ReactJS, Vega, Rails and testing frameworks like Mocha and RSpec.
Link to the one of the profile pages
I have had blogging experience, as I used to frequently blog about my internship with Wikimedia.

Link to some of the major contributions made:
https://github.com/WikiEducationFoundation/WikiEduDashboard/pull/1221
https://github.com/WikiEducationFoundation/WikiEduDashboard/commit/a9246cb17717436eb5278054cb168c13e818625e
https://github.com/WikiEducationFoundation/WikiEduDashboard/commit/298037f011c2c1a96db917b1ebb5385b3a9e5be8
https://github.com/WikiEducationFoundation/WikiEduDashboard/commit/9ac397b282010a23261b954516326ce92dfc616f

Other Projects:
Web developer, work taken as a freelancer
Link to the designs made in the first phase: https://github.com/sejalkhatri/Design/tree/master/SMA
I learned how to set up a website using the hosting platform Hostinger and also the domain setup(Dot TK). Vital part was taking client reviews and building on them, Iterative Model was followed for Development. I learned how to consider details of what is required and then summing it up to what can be done, also made the website responsive using CSS Media Queries. The project helped me develop better understanding of web technologies like jQuery(used for sliding windows), Bootstrap(image gallery).
Website Link: http://www.smaacademy.tk/

Front end developer in College Project, AutoTransliterator-PyGtk framework used

This is a desktop application(text editor) used for converting English script to Devanagari Script. It uses machine learning concepts by suggesting a script to the user by considering his previous preferences. PyGtk is used for creating User Interface and communicating with back end python scripting. XML is used to store the word frequencies and JSON format is used for ASCII mapping of letters.
I learnt PyGtk framework and underlying GTK+ library which provides all kind of visual elements and utilities for it. The documentation was done following Software Engineering documentation format, user manual is deployed with the package.
Project Link: https://github.com/sejalkhatri/autoTransliterate, u can download it and start using.

Developed website for college technical event INC'15
Impetus and Concepts is a technical event organized by PICT. The website was developed by INC Web Development Team, I learnt how to collaborate and work in sync with other people. I worked on web languages-HTML, CSS, JavaScript and Bootstrap Framework, learnt the importance of final testing before deploying.
The website gets updated every year, So you will not be able to see my work

Designed UI for Clash'14 - C/CPP coding contest
Link to the designs made: https://github.com/sejalkhatri/Design/tree/master/CLASH
Qt Creator IDE was used for development, I worked as a front end developer. The Theme was Time Evolution, so if the code was correct than the contestant was shown heading towards future, otherwise past. The UI was developed keeping in mind the Theme and it got great reviews(1000+ contestants)
This was my first technical project as a front end developer and I learnt how to work with Qt Creator.

Sek2016 created this task.Mar 31 2017, 8:08 PM
Restricted Application added subscribers: Base, Aklapper. · View Herald TranscriptMar 31 2017, 8:08 PM
Sek2016 updated the task description. (Show Details)Apr 3 2017, 4:34 AM
Sek2016 updated the task description. (Show Details)
Sek2016 updated the task description. (Show Details)Apr 3 2017, 4:46 AM
Sek2016 renamed this task from [Draft]GSoC17 Proposal to provide enhanced usability for Wiki Education Dashboard project managed by Wiki Education foundation. to GSoC17 Proposal to provide enhanced usability for Wiki Education Dashboard project managed by Wiki Education foundation..Apr 3 2017, 1:12 PM
Sek2016 renamed this task from GSoC17 Proposal to provide enhanced usability for Wiki Education Dashboard project managed by Wiki Education foundation. to GSoC17 Proposal to provide enhanced usability for Wikimedia Programs & Events Dashboard managed by Wiki Education foundation..Apr 3 2017, 3:09 PM
Ragesoss updated the task description. (Show Details)Apr 4 2017, 4:52 PM

@Sek2016 I think the biggest thing you could do to improve this would be to expand the synopsis more. Demonstrate your understanding of the app in broad strokes, in a way that ties together the theme of the proposal into a more of a story and makes a case for its importance.

Thanks @Ragesoss for reviewing, I will update the proposal accordingly.

Quick summary:

Wiki Ed Experience:
Over the course of my Internship I got many experiences which includes getting in touch with Dashboard users from all across the world(Israel, Canada, USA, Egypt, Serbia, Czech Republic), interacting with them, organizing user testing sessions on my own and helping them with their frustrations and understanding their needs.

My Journey:

  • For the first part of my Internship I did some code refining for the user contribution stats and successfully made them available on the user profile pages, along with that I solved some issues listed on my GSoC proposal.
  • For the second part of my Internship I started conducting user testing sessions, solved some discovered issues right away and for others I opened issues on GitHub.
  • For the third of my Internship, I started working on enhancing the usability of Dashboard on Mobile devices. The current navigation bar is over-crowded, so to make it accessible I replaced it with hamburger menu layout. Solved problems like the overlapping of course details columns and inflexibility in using the Dashboard features on small screen devices.
  • For the fourth(last part) of my Internship comes the most adventurous part — attending Wikimania’17, Montreal. I finally met @Ragesoss and @Capt_Swing (yaay!!) and spent memorable time with them. For the first time I got the opportunity to share my work with Wikimedians at the Wikimania Hackathon Showcase(more about the hackathon and Dashboard showcase at 47:45 ) with the help of @Ragesoss . Also I had a short meeting with @Capt_Swing, to take his help on creating a user testing report for properly documenting my work. He shared relevant links and also some of his work reports to give me a gist about how an ideal report needs to be. That was a fun meet as Jonathan also suggested some universities in USA regarding my plans of pursuing Masters in Human Computer Interaction .

Acknowledgements:
I would like to say Thank you to the Wikimedia GSoC administrators(@Sumit , @srishakatux and others) for keeping the work flow smooth and organizing this program.

More about my GSoC Experience at my Blog post! - here

Hi! Is there anything remaining in this task before it can be resolved? thank you!

Ragesoss closed this task as Resolved.Jan 11 2018, 8:49 PM

Nope.